=== modified file '.bzrignore'
--- .bzrignore	2008-10-03 09:32:30 +0000
+++ .bzrignore	2008-09-26 05:04:15 +0000
@@ -5,9 +5,7 @@
 debian/po/messages.mo
 debian/po/templates.pot
 keydir
-man
 plugin-runner
-plugins.d/askpass-fifo
 plugins.d/mandos-client
 plugins.d/password-prompt
 plugins.d/splashy

=== modified file 'INSTALL'
--- INSTALL	2008-10-28 18:00:20 +0000
+++ INSTALL	2008-09-08 18:54:47 +0000
@@ -97,28 +97,10 @@
      and append this to the file "/etc/mandos/clients.conf" *on the
      server computer*.
   
-  4. Configure the client to use the correct network interface.  The
-     default is "eth0", and if this needs to be adjusted, it will be
-     necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
-     change the line there.  If that file is changed, the initrd.img
-     file must be updated, possibly using the following command:
-     
-	# update-initramfs -k all -u
-  
-  5. On the server computer, start the server by running the command
+  4. On the server computer, start the server by running the command
      For Debian: su -c 'invoke-rc.d mandos start'
      For Ubuntu: sudo invoke-rc.d mandos start
      
-     At this point, it is possible to verify that the correct password
-     will be received by the client by running the command:
-     
-	# /usr/lib/mandos/plugins.d/mandos-client \
-		--pubkey=/etc/keys/mandos/pubkey.txt \
-		--seckey=/etc/keys/mandos/seckey.txt; echo
-     
-     This command should retrieve the password from the server,
-     decrypt it, and output it to standard output.
-     
      After this, the client computer should be able to reboot without
      needing a password entered on the console, as long as it does not
      take more than an hour to reboot.
@@ -127,6 +109,6 @@
   
   You may want to tighten or loosen the timeouts in the server
   configuration files; see mandos.conf(5) and mandos-clients.conf(5).
-  If IPsec is not used, it is suggested that a more cryptographically
+  Is IPsec is not used, it is suggested that a more cryptographically
   secure checker program is used and configured, since without IPsec
   ping packets can be faked.

=== modified file 'Makefile'
--- Makefile	2008-10-28 18:00:20 +0000
+++ Makefile	2008-09-30 03:19:39 +0000
@@ -9,14 +9,10 @@
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>
-FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIE -pie
-LINK_FORTIFY=-z relro -pie
+FORTIFY=-D_FORTIFY_SOURCE=2 # -fstack-protector-all
 #COVERAGE=--coverage
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
-htmldir=man
-version=1.0.2
-SED=sed
 
 ## Use these settings for a traditional /usr/local install
 # PREFIX=$(DESTDIR)/usr/local
@@ -43,9 +39,8 @@
 
 # Do not change these two
 CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
-	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
-	-DVERSION='"$(version)"'
-LDFLAGS=$(COVERAGE) $(LINK_FORTIFY)
+	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS)
+LDFLAGS=$(COVERAGE)
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=cd $(dir $<); xsltproc --nonet --xinclude \
@@ -58,7 +53,7 @@
 	$(notdir $<); \
 	$(MANPOST) $(notdir $@)
 # DocBook-to-man post-processing to fix a '\n' escape bug
-MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
+MANPOST=sed --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
 DOCBOOKTOHTML=xsltproc --nonet --xinclude \
 	--param make.year.ranges		1 \
@@ -70,107 +65,72 @@
 	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
 	$<; $(HTMLPOST) $@
 # Fix citerefentry links
-HTMLPOST=$(SED) --in-place \
-	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'
+HTMLPOST=sed --in-place --expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'
 
 PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo
-CPROGS=plugin-runner $(PLUGINS)
-PROGS=mandos mandos-keygen $(CPROGS)
+PROGS=plugin-runner $(PLUGINS)
 DOCS=mandos.8 plugin-runner.8mandos mandos-keygen.8 \
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos mandos.conf.5 \
-	plugins.d/usplash.8mandos plugins.d/splashy.8mandos \
-	plugins.d/askpass-fifo.8mandos mandos-clients.conf.5
+	mandos-clients.conf.5
 
 htmldocs=$(addsuffix .xhtml,$(DOCS))
 
-objects=$(addsuffix .o,$(CPROGS))
+objects=$(addsuffix .o,$(PROGS))
 
-all: $(PROGS) mandos.lsm
+all: $(PROGS)
 
 doc: $(DOCS)
 
 html: $(htmldocs)
 
-%.5: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOMAN)
-%.5.xhtml: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-%.8: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOMAN)
-%.8.xhtml: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-%.8mandos: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOMAN)
-%.8mandos.xhtml: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-mandos.8: mandos.xml common.ent mandos-options.xml overview.xml \
-		legalnotice.xml
-	$(DOCBOOKTOMAN)
-mandos.8.xhtml: mandos.xml common.ent mandos-options.xml \
-		overview.xml legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-mandos-keygen.8: mandos-keygen.xml common.ent overview.xml \
-		legalnotice.xml
-	$(DOCBOOKTOMAN)
-mandos-keygen.8.xhtml: mandos-keygen.xml common.ent overview.xml \
-		 legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-mandos.conf.5: mandos.conf.xml common.ent mandos-options.xml \
-		legalnotice.xml
-	$(DOCBOOKTOMAN)
-mandos.conf.5.xhtml: mandos.conf.xml common.ent mandos-options.xml \
-		legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-plugin-runner.8mandos: plugin-runner.xml common.ent overview.xml \
-		legalnotice.xml
-	$(DOCBOOKTOMAN)
-plugin-runner.8mandos.xhtml: plugin-runner.xml common.ent \
-		overview.xml legalnotice.xml
+%.5: %.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+%.5.xhtml: %.xml legalnotice.xml
+	$(DOCBOOKTOHTML)
+
+%.8: %.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+%.8.xhtml: %.xml legalnotice.xml
+	$(DOCBOOKTOHTML)
+
+%.8mandos: %.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+%.8mandos.xhtml: %.xml legalnotice.xml
+	$(DOCBOOKTOHTML)
+
+mandos.8: mandos.xml mandos-options.xml overview.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+mandos.8.xhtml: mandos.xml mandos-options.xml overview.xml \
+		legalnotice.xml
+	$(DOCBOOKTOHTML)
+
+mandos-keygen.8: mandos-keygen.xml overview.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+mandos-keygen.8.xhtml: mandos-keygen.xml overview.xml legalnotice.xml
+	$(DOCBOOKTOHTML)
+
+mandos.conf.5: mandos.conf.xml mandos-options.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+mandos.conf.5.xhtml: mandos.conf.xml mandos-options.xml legalnotice.xml
+	$(DOCBOOKTOHTML)
+
+plugin-runner.8mandos: plugin-runner.xml overview.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+plugin-runner.8mandos.xhtml: plugin-runner.xml overview.xml \
+		legalnotice.xml
 	$(DOCBOOKTOHTML)
 
 plugins.d/mandos-client.8mandos: plugins.d/mandos-client.xml \
-					common.ent \
 					mandos-options.xml \
 					overview.xml legalnotice.xml
 	$(DOCBOOKTOMAN)
 plugins.d/mandos-client.8mandos.xhtml: plugins.d/mandos-client.xml \
-					common.ent \
 					mandos-options.xml \
 					overview.xml legalnotice.xml
 	$(DOCBOOKTOHTML)
 
-# Update all these files with version number $(version)
-common.ent: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(<ENTITY VERSION "\)[^"]*">$$/\1$(version)"/' \
-		$@
-
-mandos: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
-		$@
-
-mandos-keygen: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
-		$@
-
-mandos.lsm: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(Version:\).*/\1\t$(version)/' \
-		$@
-	$(SED) --in-place \
-		--expression='s/^\(Entered-date:\).*/\1\t$(shell date --rfc-3339=date --reference=Makefile)/' \
-		$@
-
 plugins.d/mandos-client: plugins.d/mandos-client.o
 	$(LINK.o) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) \
 		$(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
@@ -180,14 +140,14 @@
 	uninstall-client purge purge-server purge-client
 
 clean:
-	-rm --force $(CPROGS) $(objects) $(htmldocs) $(DOCS) core
+	-rm --force $(PROGS) $(objects) $(htmldocs) $(DOCS) core
 
 distclean: clean
 mostlyclean: clean
 maintainer-clean: clean
 	-rm --force --recursive keydir confdir
 
-check:	all
+check:
 	./mandos --check
 
 # Run the client with a local config and key
@@ -217,10 +177,9 @@
 
 install: install-server install-client-nokey
 
-install-html: html
-	install --directory $(htmldir)
-	install --mode=u=rw,go=r --target-directory=$(htmldir) \
-		$(htmldocs)
+install-html: $(htmldocs)
+	install --directory man
+	install --mode=u=rw,go=r --target-directory=man $(htmldocs)
 
 install-server: doc
 	install --directory $(CONFDIR)
@@ -285,12 +244,6 @@
 		> $(MANDIR)/man8/password-prompt.8mandos.gz
 	gzip --best --to-stdout plugins.d/mandos-client.8mandos \
 		> $(MANDIR)/man8/mandos-client.8mandos.gz
-	gzip --best --to-stdout plugins.d/usplash.8mandos \
-		> $(MANDIR)/man8/usplash.8mandos.gz
-	gzip --best --to-stdout plugins.d/splashy.8mandos \
-		> $(MANDIR)/man8/splashy.8mandos.gz
-	gzip --best --to-stdout plugins.d/askpass-fifo.8mandos \
-		> $(MANDIR)/man8/askpass-fifo.8mandos.gz
 
 install-client: install-client-nokey
 # Post-installation stuff
@@ -319,17 +272,16 @@
 		$(PREFIX)/lib/mandos/plugins.d/mandos-client \
 		$(PREFIX)/lib/mandos/plugins.d/usplash \
 		$(PREFIX)/lib/mandos/plugins.d/splashy \
-		$(PREFIX)/lib/mandos/plugins.d/askpass-fifo \
 		$(INITRAMFSTOOLS)/hooks/mandos \
 		$(INITRAMFSTOOLS)/conf-hooks.d/mandos \
 		$(INITRAMFSTOOLS)/scripts/local-top/mandos \
 		$(MANDIR)/man8/plugin-runner.8mandos.gz \
 		$(MANDIR)/man8/mandos-keygen.8.gz \
 		$(MANDIR)/man8/password-prompt.8mandos.gz \
-		$(MANDIR)/man8/usplash.8mandos.gz \
-		$(MANDIR)/man8/splashy.8mandos.gz \
-		$(MANDIR)/man8/askpass-fifo.8mandos.gz \
 		$(MANDIR)/man8/mandos-client.8mandos.gz
+	if [ "$(CONFDIR)" != "$(PREFIX)/lib/mandos" ]; then \
+		rm --force $(CONFDIR)/plugins.d/README; \
+	fi
 	-rmdir $(PREFIX)/lib/mandos/plugins.d $(CONFDIR)/plugins.d \
 		 $(PREFIX)/lib/mandos $(CONFDIR) $(KEYDIR)
 	update-initramfs -k all -u

=== removed file 'NEWS'
--- NEWS	2008-10-17 18:56:25 +0000
+++ NEWS	1970-01-01 00:00:00 +0000
@@ -1,23 +0,0 @@
-This NEWS file records noteworthy changes, very tersely.
-See the manual for detailed information.
-
-Version 1.0.2 (2008-10-17)
-* mandos-keygen now signs the encrypted key blobs.  This signature is
-  not currently verified by mandos-client, but this may change in the
-  future.
-
-Version 1.0.1 (2008-10-07)
-* Server
-** Expand environment variables and ~user in clients.conf's "secfile"
-   The "secfile" option in /etc/mandos/clients.conf now expands
-   "~user/foo" and "$ENVVAR" strings.
-
-* Client (plugin-runner, plugins, etc.)
-** Manual pages for the usplash, splashy, and askpass-fifo plugins.
-   All plugins now have man pages.
-** More secure compilation and linking flags.
-   All programs are now compiled with "-fstack-protector-all -fPIE
-   -pie", and linked using "-z relro -pie" for additional security.
-
-* There is now a "NEWS" file (this one), giving a history of
-  noteworthy changes.

=== modified file 'README'
--- README	2008-10-28 18:00:20 +0000
+++ README	2008-09-30 03:19:39 +0000
@@ -143,11 +143,11 @@
   first to find a password and provide it to the plugin runner.
   
   Three additional plugins are provided:
-  * usplash(8mandos)
+  * usplash
     This prompts for a password when using usplash(8).
-  * splashy(8mandos)
+  * splashy
     This prompts for a password when using splashy(8).
-  * askpass-fifo(8mandos)
+  * askpass-fifo
     To provide compatibility with the "askpass" program from
     cryptsetup, this plugin listens to the same FIFO as askpass would
     do.
@@ -161,7 +161,7 @@
 * Copyright
 
     Copyright © 2008 Teddy Hogeborn
-    Copyright © 2008 Björn Påhlsson
+                2008 Björn Påhlsson
   
 ** License:
    

=== modified file 'TODO'
--- TODO	2008-11-11 16:07:18 +0000
+++ TODO	2008-09-30 03:19:39 +0000
@@ -1,11 +1,14 @@
 -*- org -*-
 
+* DONE plugin-runner
+
 * mandos-client
 ** TODO [#B] Temporarily lower kernel log level
    for less printouts during sucessfull boot.
-   klogctl(6, NULL, 0); klogctl(7, NULL, 0);
 ** TODO [#C] IPv4 support
 
+* DONE password-prompt
+
 * mandos (server)
 ** TODO [#B] Log level				:bugs:
 ** TODO /etc/mandos/clients.d/*.conf
@@ -14,23 +17,6 @@
 ** TODO [#B] Run-time communication with server :bugs:
    Probably using D-Bus
    See also [[*Mandos-tools]]
-*** Client class
-    Remove unneeded Get* methods?
-*** Main server
-    + Clients
-      out_signature="ao"
-      Does this have to be "GetClients" so as not to collide with the
-      interface name?
-    + SetLogLevel
-      syslogger.setLevel(logging.WARNING)
-    + Quit
-    + GetClientsProperties "aa{sv}":
-      dbus.Array(dbus.Dictionary({dbus.String("name"):
-                                  dbus.String("foo", variant_level=1),
-                                  dbus.String("created"):
-				  dbus.Array(dbus.Int16(2008), ...,
-                                             variant_level=1)}))
-    + [[http://log.ometer.com/2007-05.html][Best D-Bus practices]]
 ** TODO Implement --foreground			:bugs:
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
@@ -38,8 +24,6 @@
 ** TODO Date+time on console log messages	:bugs:
    Is this the default?
 ** TODO delete hook when clients fall out by timeout
-   This will not be strictly necessary when the D-Bus interface is
-   implemented.
 
 * Mandos-tools/utilities
   All of this probably using D-Bus
@@ -48,11 +32,19 @@
 ** TODO Enable client
 ** TODO Reset timer
 
-* mandos-keygen
-** TODO "--secfile" option
-   Using the "secfile" option instead of "secret"
-** TODO [#B] "--test" option
-   For testing decryption before rebooting.
+* Man pages
+** TODO Use xinclude for all common sections
+   Like authors, etc.
+
+
+* Installer
+** Client-side
+*** mandos-keygen
+**** TODO "--secfile" option
+     Using the "secfile" option instead of "secret"
+**** TODO [#B] "--test" option
+     For testing decryption before rebooting.
+
 
 * [#A] Package
 ** /usr/share/initramfs-tools/hooks/mandos
@@ -61,6 +53,20 @@
     question.
 ** TODO /etc/bash_completion.d/mandos
    From XML sources directly?
+** TODO unperish
+
+* TODO Web site
+** DONE http://www.fukt.bsnet.se/mandos
+   Redirects to the wiki page
+** TODO http://wiki.fukt.bsnet.se/wiki/Mandos
+   http://liw.fi/free-software-website/
+
+* Mailing list
+** DONE mandos-dev
+*** TODO http://gmane.org/subscribe.php
+
+* TODO Announce project on Usenet
+  [[news:comp.os.linux.announce]]
 
 
 #+STARTUP: showall

=== removed file 'common.ent'
--- common.ent	2008-09-30 07:23:39 +0000
+++ common.ent	1970-01-01 00:00:00 +0000
@@ -1,3 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!-- Edited by Makefile -->
-<!ENTITY version "1.0">

=== modified file 'debian/changelog'
--- debian/changelog	2008-10-17 18:56:25 +0000
+++ debian/changelog	2008-09-17 00:34:09 +0000
@@ -1,29 +1,5 @@
-mandos (1.0.2-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/copyright: Rewritten to conform to
-    <http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233>.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Fri, 17 Oct 2008 20:42:12 +0200
-
-mandos (1.0.1-1) unstable; urgency=low
-
-  * New upstream release.
-  * Separate /usr/share/doc/mandos-client/README.Debian into sections with
-    headlines.  Add instructions on how to test the server and verify the
-    password.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 07 Oct 2008 23:07:23 +0200
-
-mandos (1.0-2) unstable; urgency=low
-
-  * Added comments in debian/*.lintian-overrides files.  Added Debian
-    revison number to version number.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Wed, 01 Oct 2008 17:23:35 +0200
-
-mandos (1.0-1) unstable; urgency=low
-
-  * Initial Release. (Closes: #500727).
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 30 Sep 2008 21:58:43 +0200
+mandos (1.0) unstable; urgency=low
+
+  * Initial Release.
+
+ -- Mandos Maintainers <mandos@fukt.bsnet.se>  Sun, 07 Sep 2008 11:55:51 +0200

=== modified file 'debian/copyright'
--- debian/copyright	2008-10-15 19:54:11 +0000
+++ debian/copyright	2008-09-17 00:34:09 +0000
@@ -1,26 +1,27 @@
-Format-Specification:
- http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233
-Upstream-Name: Mandos
-Upstream-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Upstream-Source: <http://www.fukt.bsnet.se/mandos>
-
-Files: *
-Copyright: Copyright © 2008 Teddy Hogeborn
-Copyright: Copyright © 2008 Björn Påhlsson
-License: GPL-3+
+Authors: Teddy Hogeborn, Björn Påhlsson
+
+Homepage: <http://www.fukt.bsnet.se/mandos>
+
+Copyright:
+
+    Copyright © 2008 Teddy Hogeborn
+                2008 Björn Påhlsson
+
+License:
+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as
     published by the Free Software Foundation, either version 3 of the
     License, or (at your option) any later version.
-    .
+
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     General Public License for more details.
-    .
+
     You should have received a copy of the GNU General Public License
     along with this program.  If not, see
     <http://www.gnu.org/licenses/>.
-    .
-    On Debian systems, the complete text of the GNU General Public
-    License can be found in "/usr/share/common-licenses/GPL".
+
+On Debian systems, the complete text of the GNU General Public License
+can be found in "/usr/share/common-licenses/GPL".

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2008-10-05 17:38:31 +0000
+++ debian/mandos-client.README.Debian	2008-09-19 20:54:58 +0000
@@ -1,45 +1,23 @@
-* Configure The Server
-  
-  A client key has been automatically created in /etc/keys/mandos.
-  The next step is to run "mandos-keygen --password" to get a config
-  file section.  This should be appended to /etc/mandos/clients.conf
-  on the Mandos server.
-
-* Use the Correct Network Interface
-  
-  If some other network interface than "eth0" is used, it will be
-  necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
-  change the line there.  If this is done, it will be necessary to
-  update the initrd image by doing "update-initramfs -k all -u".
-
-* Test the Server
-  
-  After the server has been started and this client's key added, it is
-  possible to verify that the correct password will be received by
-  this client by running the command, on the client:
-  
-	# /usr/lib/mandos/plugins.d/mandos-client \
-		--pubkey=/etc/keys/mandos/pubkey.txt \
-		--seckey=/etc/keys/mandos/seckey.txt; echo
-  
-  This command should retrieve the password from the server, decrypt
-  it, and output it to standard output.  It is now possible to verify
-  the correctness of the password before rebooting.
-
-* User-Supplied Plugins
-
-  Any plugins found in /etc/mandos/plugins.d will override and add to
-  the normal Mandos plugins.  When adding or changing plugins, do not
-  forget to update the initital RAM disk image:
-
-	# update-initramfs -k all -u
-
-* Do *NOT* Edit /etc/crypttab
-
-  It is NOT necessary to edit /etc/crypttab to specify
-  /usr/lib/mandos/plugin-runner as a keyscript for the root file
-  system; if no keyscript is given for the root file system, the
-  Mandos client will be the new default way for getting a password for
-  the root file system when booting.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Sun,  5 Oct 2008 19:04:26 +0200
+A client key has been automatically created in /etc/keys/mandos.  The
+next step is to run "mandos-keygen --password" to get a config file
+stanza to copy and paste into /etc/mandos/clients.conf on the Mandos
+server.
+
+Also, if some other network interface than "eth0" is used, it will be
+necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
+change the line there.  If this file is changed, it will be necessary
+to update the initrd image by doing "update-initramfs -k all -u".
+
+Any plugins found in /etc/mandos/plugins.d will override and add to
+the normal Mandos plugins.  When adding or changing plugins, do not
+forget to update the initital RAM disk image:
+
+# update-initramfs -k all -u
+
+It is NOT necessary to edit /etc/crypttab to specify
+/usr/lib/mandos/plugin-runner as a keyscript for the root file system;
+if no keyscript is given for the root file system, the Mandos client
+will be the new default way for getting a password for the root file
+system when booting.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Fri, 19 Sep 2008 22:50:16 +0200

=== modified file 'debian/mandos-client.docs'
--- debian/mandos-client.docs	2008-10-18 11:17:22 +0000
+++ debian/mandos-client.docs	2008-09-19 13:50:22 +0000
@@ -1,3 +1,2 @@
-NEWS
 README
 TODO

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2008-10-01 15:29:01 +0000
+++ debian/mandos-client.lintian-overrides	2008-09-26 19:47:21 +0000
@@ -1,32 +1,7 @@
-# This example command line is long without spaces, but it must be
-# that way; it's part of the point of showing it.
-#
 mandos-client binary: manpage-has-errors-from-man usr/share/man/man8/plugin-runner.8mandos.gz 297: warning [p 4, 5.8i]: can't break line
-
-# This directory contains secret client key files.
-#
 mandos-client binary: non-standard-dir-perm etc/keys/mandos/ 0700 != 0755
-
-# The directory /usr/lib/mandos/plugins.d contains setuid binaries
-# which are not meant to be run outside an initial RAM disk
-# environment (except for test purposes).  It would be insecure to
-# allow anyone to run them.
-#
-mandos-client binary: non-standard-dir-perm usr/lib/mandos/plugins.d/ 0700 != 0755
-
-# These binaries must be setuid root, since they need root powers, but
-# are started by plugin-runner(8mandos), which runs all plugins as
-# user/group "mandos".  These binaries are not run in a running
-# system, but in an initial RAM disk environment.  Here they are
-# protected from non-root access by the directory permissions, above.
-#
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/mandos-client 4755 root/root
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/askpass-fifo 4755 root/root
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/splashy 4755 root/root
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/usplash 4755 root/root
-
-# The directory /etc/mandos/plugins.d can be used by local system
-# administrators to place plugins in, overriding and complementing
-# /usr/lib/mandos/plugins.d, and must be likewise protected.
-#
-mandos-client binary: non-standard-dir-perm etc/mandos/plugins.d/ 0700 != 0755
+mandos-client binary: non-standard-dir-perm usr/lib/mandos/plugins.d/ 0700 != 0755

=== modified file 'debian/mandos.docs'
--- debian/mandos.docs	2008-10-18 11:17:22 +0000
+++ debian/mandos.docs	2008-09-19 13:50:22 +0000
@@ -1,3 +1,2 @@
-NEWS
 README
 TODO

=== modified file 'debian/mandos.lintian-overrides'
--- debian/mandos.lintian-overrides	2008-10-01 15:29:01 +0000
+++ debian/mandos.lintian-overrides	2008-09-17 00:34:09 +0000
@@ -1,4 +1,1 @@
-# This config file will normally have encrypted secret client keys in
-# it, so it must be kept unreadable for non-root users.
-#
 mandos binary: non-standard-file-perm etc/mandos/clients.conf 0600 != 0644

=== modified file 'debian/rules'
--- debian/rules	2008-09-30 18:59:44 +0000
+++ debian/rules	2008-09-21 12:04:02 +0000
@@ -72,7 +72,6 @@
 	dh_compress
 	dh_fixperms --exclude etc/keys/mandos \
 		--exclude etc/mandos/clients.conf \
-		--exclude etc/mandos/plugins.d \
 		--exclude usr/lib/mandos/plugins.d
 	dh_installdeb
 	dh_shlibdeps

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2008-11-01 02:26:00 +0000
+++ initramfs-tools-hook	2008-09-19 00:54:24 +0000
@@ -89,7 +89,7 @@
 	continue
     fi
     case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert) : ;;
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-new|*.dpkg-divert) : ;;
 	"*") :;;
 	*) copy_exec "$file" "${PLUGINDIR}";;
     esac
@@ -99,7 +99,7 @@
 for file in /etc/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
     case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert) : ;;
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-new|*.dpkg-divert) : ;;
 	"*") :;;
 	*) copy_exec "$file" "${PLUGINDIR}";;
     esac

=== modified file 'mandos'
--- mandos	2008-11-11 16:07:18 +0000
+++ mandos	2008-09-26 21:54:54 +0000
@@ -11,8 +11,7 @@
 # and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008 Teddy Hogeborn
-# Copyright © 2008 Björn Påhlsson
+# Copyright © 2008 Teddy Hogeborn & Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,7 +30,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division, with_statement, absolute_import
+from __future__ import division
 
 import SocketServer
 import socket
@@ -56,24 +55,22 @@
 import logging
 import logging.handlers
 import pwd
-from contextlib import closing
 
 import dbus
-import dbus.service
 import gobject
 import avahi
 from dbus.mainloop.glib import DBusGMainLoop
 import ctypes
 import ctypes.util
 
-version = "1.0.2"
+version = "1.0"
 
 logger = logging.Logger('mandos')
-syslogger = (logging.handlers.SysLogHandler
-             (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
-              address = "/dev/log"))
-syslogger.setFormatter(logging.Formatter
-                       ('Mandos: %(levelname)s: %(message)s'))
+syslogger = logging.handlers.SysLogHandler\
+            (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
+             address = "/dev/log")
+syslogger.setFormatter(logging.Formatter\
+                        ('Mandos: %(levelname)s: %(message)s'))
 logger.addHandler(syslogger)
 
 console = logging.StreamHandler()
@@ -112,13 +109,16 @@
                   a sensible number of times
     """
     def __init__(self, interface = avahi.IF_UNSPEC, name = None,
-                 servicetype = None, port = None, TXT = None,
-                 domain = "", host = "", max_renames = 32768):
+                 servicetype = None, port = None, TXT = None, domain = "",
+                 host = "", max_renames = 32768):
         self.interface = interface
         self.name = name
         self.type = servicetype
         self.port = port
-        self.TXT = TXT if TXT is not None else []
+        if TXT is None:
+            self.TXT = []
+        else:
+            self.TXT = TXT
         self.domain = domain
         self.host = host
         self.rename_count = 0
@@ -133,9 +133,9 @@
         self.name = server.GetAlternativeServiceName(self.name)
         logger.info(u"Changing Zeroconf service name to %r ...",
                     str(self.name))
-        syslogger.setFormatter(logging.Formatter
+        syslogger.setFormatter(logging.Formatter\
                                ('Mandos (%s): %%(levelname)s:'
-                                ' %%(message)s' % self.name))
+                               ' %%(message)s' % self.name))
         self.remove()
         self.add()
         self.rename_count += 1
@@ -147,10 +147,10 @@
         """Derived from the Avahi example code"""
         global group
         if group is None:
-            group = dbus.Interface(bus.get_object
-                                   (avahi.DBUS_NAME,
+            group = dbus.Interface\
+                    (bus.get_object(avahi.DBUS_NAME,
                                     server.EntryGroupNew()),
-                                   avahi.DBUS_INTERFACE_ENTRY_GROUP)
+                     avahi.DBUS_INTERFACE_ENTRY_GROUP)
             group.connect_to_signal('StateChanged',
                                     entry_group_state_changed)
         logger.debug(u"Adding Zeroconf service '%s' of type '%s' ...",
@@ -170,7 +170,7 @@
 # End of Avahi example code
 
 
-class Client(dbus.service.Object):
+class Client(object):
     """A representation of a client host served by this server.
     Attributes:
     name:      string; from the config file, used in log messages
@@ -178,9 +178,8 @@
                  uniquely identify the client
     secret:    bytestring; sent verbatim (over TLS) to client
     host:      string; available for use by the checker command
-    created:   datetime.datetime(); (UTC) object creation
-    started:   datetime.datetime(); (UTC) last started
-    last_checked_ok: datetime.datetime(); (UTC) or None
+    created:   datetime.datetime(); object creation, not client host
+    last_checked_ok: datetime.datetime() or None if not yet checked OK
     timeout:   datetime.timedelta(); How long from last_checked_ok
                                      until this client is invalid
     interval:  datetime.timedelta(); How often to start a new checker
@@ -202,20 +201,18 @@
     _interval_milliseconds: - '' -
     """
     def _set_timeout(self, timeout):
-        "Setter function for the 'timeout' attribute"
+        "Setter function for 'timeout' attribute"
         self._timeout = timeout
         self._timeout_milliseconds = ((self.timeout.days
                                        * 24 * 60 * 60 * 1000)
                                       + (self.timeout.seconds * 1000)
                                       + (self.timeout.microseconds
                                          // 1000))
-        # Emit D-Bus signal
-        self.TimeoutChanged(self._timeout_milliseconds)
-    timeout = property(lambda self: self._timeout, _set_timeout)
+    timeout = property(lambda self: self._timeout,
+                       _set_timeout)
     del _set_timeout
-    
     def _set_interval(self, interval):
-        "Setter function for the 'interval' attribute"
+        "Setter function for 'interval' attribute"
         self._interval = interval
         self._interval_milliseconds = ((self.interval.days
                                         * 24 * 60 * 60 * 1000)
@@ -223,18 +220,13 @@
                                           * 1000)
                                        + (self.interval.microseconds
                                           // 1000))
-        # Emit D-Bus signal
-        self.IntervalChanged(self._interval_milliseconds)
-    interval = property(lambda self: self._interval, _set_interval)
+    interval = property(lambda self: self._interval,
+                        _set_interval)
     del _set_interval
-    
     def __init__(self, name = None, stop_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
         'checker_command' attribute and *not* the 'checker'
         attribute."""
-        dbus.service.Object.__init__(self, bus,
-                                     "/Mandos/clients/%s"
-                                     % name.replace(".", "_"))
         if config is None:
             config = {}
         self.name = name
@@ -242,22 +234,20 @@
         # Uppercase and remove spaces from fingerprint for later
         # comparison purposes with return value from the fingerprint()
         # function
-        self.fingerprint = (config["fingerprint"].upper()
-                            .replace(u" ", u""))
+        self.fingerprint = config["fingerprint"].upper()\
+                           .replace(u" ", u"")
         logger.debug(u"  Fingerprint: %s", self.fingerprint)
         if "secret" in config:
             self.secret = config["secret"].decode(u"base64")
         elif "secfile" in config:
-            with closing(open(os.path.expanduser
-                              (os.path.expandvars
-                               (config["secfile"])))) as secfile:
-                self.secret = secfile.read()
+            secfile = open(config["secfile"])
+            self.secret = secfile.read()
+            secfile.close()
         else:
             raise TypeError(u"No secret or secfile for client %s"
                             % self.name)
         self.host = config.get("host", "")
-        self.created = datetime.datetime.utcnow()
-        self.started = None
+        self.created = datetime.datetime.now()
         self.last_checked_ok = None
         self.timeout = string_to_delta(config["timeout"])
         self.interval = string_to_delta(config["interval"])
@@ -267,28 +257,27 @@
         self.stop_initiator_tag = None
         self.checker_callback_tag = None
         self.check_command = config["checker"]
-    
     def start(self):
         """Start this client's checker and timeout hooks"""
-        self.started = datetime.datetime.utcnow()
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (self._interval_milliseconds,
-                                       self.start_checker))
+        self.checker_initiator_tag = gobject.timeout_add\
+                                     (self._interval_milliseconds,
+                                      self.start_checker)
         # Also start a new checker *right now*.
         self.start_checker()
         # Schedule a stop() when 'timeout' has passed
-        self.stop_initiator_tag = (gobject.timeout_add
-                                   (self._timeout_milliseconds,
-                                    self.stop))
-        # Emit D-Bus signal
-        self.StateChanged(True)
-    
+        self.stop_initiator_tag = gobject.timeout_add\
+                                  (self._timeout_milliseconds,
+                                   self.stop)
     def stop(self):
-        """Stop this client."""
-        if getattr(self, "started", None) is not None:
+        """Stop this client.
+        The possibility that a client might be restarted is left open,
+        but not currently used."""
+        # If this client doesn't have a secret, it is already stopped.
+        if hasattr(self, "secret") and self.secret:
             logger.info(u"Stopping client %s", self.name)
+            self.secret = None
         else:
             return False
         if getattr(self, "stop_initiator_tag", False):
@@ -300,49 +289,31 @@
         self.stop_checker()
         if self.stop_hook:
             self.stop_hook(self)
-        self.started = None
-        # Emit D-Bus signal
-        self.StateChanged(False)
         # Do not run this again if called by a gobject.timeout_add
         return False
-    
     def __del__(self):
         self.stop_hook = None
         self.stop()
-    
     def checker_callback(self, pid, condition):
         """The checker has completed, so take appropriate actions."""
+        now = datetime.datetime.now()
         self.checker_callback_tag = None
         self.checker = None
-        if (os.WIFEXITED(condition) 
-            and (os.WEXITSTATUS(condition) == 0)):
+        if os.WIFEXITED(condition) \
+               and (os.WEXITSTATUS(condition) == 0):
             logger.info(u"Checker for %(name)s succeeded",
                         vars(self))
-            # Emit D-Bus signal
-            self.CheckerCompleted(True)
-            self.bump_timeout()
+            self.last_checked_ok = now
+            gobject.source_remove(self.stop_initiator_tag)
+            self.stop_initiator_tag = gobject.timeout_add\
+                                      (self._timeout_milliseconds,
+                                       self.stop)
         elif not os.WIFEXITED(condition):
             logger.warning(u"Checker for %(name)s crashed?",
                            vars(self))
-            # Emit D-Bus signal
-            self.CheckerCompleted(False)
         else:
             logger.info(u"Checker for %(name)s failed",
                         vars(self))
-            # Emit D-Bus signal
-            self.CheckerCompleted(False)
-    
-    def bump_timeout(self):
-        """Bump up the timeout for this client.
-        This should only be called when the client has been seen,
-        alive and well.
-        """
-        self.last_checked_ok = datetime.datetime.utcnow()
-        gobject.source_remove(self.stop_initiator_tag)
-        self.stop_initiator_tag = (gobject.timeout_add
-                                   (self._timeout_milliseconds,
-                                    self.stop))
-    
     def start_checker(self):
         """Start a new checker subprocess if one is not running.
         If a checker already exists, leave it running and do
@@ -380,17 +351,14 @@
                 self.checker = subprocess.Popen(command,
                                                 close_fds=True,
                                                 shell=True, cwd="/")
-                self.checker_callback_tag = (gobject.child_watch_add
-                                             (self.checker.pid,
-                                              self.checker_callback))
-                # Emit D-Bus signal
-                self.CheckerStarted(command)
+                self.checker_callback_tag = gobject.child_watch_add\
+                                            (self.checker.pid,
+                                             self.checker_callback)
             except OSError, error:
                 logger.error(u"Failed to start subprocess: %s",
                              error)
         # Re-run this periodically if run by gobject.timeout_add
         return True
-    
     def stop_checker(self):
         """Force the checker process, if any, to stop."""
         if self.checker_callback_tag:
@@ -408,183 +376,26 @@
             if error.errno != errno.ESRCH: # No such process
                 raise
         self.checker = None
-    
     def still_valid(self):
         """Has the timeout not yet passed for this client?"""
-        if not self.started:
-            return False
-        now = datetime.datetime.utcnow()
+        now = datetime.datetime.now()
         if self.last_checked_ok is None:
             return now < (self.created + self.timeout)
         else:
             return now < (self.last_checked_ok + self.timeout)
-    
-    ## D-Bus methods & signals
-    _interface = u"org.mandos_system.Mandos.Client"
-    
-    def _datetime_to_dbus_struct(dt):
-        return dbus.Struct(dt.year, dt.month, dt.day, dt.hour,
-                           dt.minute, dt.second, dt.microsecond,
-                           signature="nyyyyyu")
-    
-    # BumpTimeout - method
-    BumpTimeout = dbus.service.method(_interface)(bump_timeout)
-    BumpTimeout.__name__ = "BumpTimeout"
-    
-    # IntervalChanged - signal
-    @dbus.service.signal(_interface, signature="t")
-    def IntervalChanged(self, t):
-        "D-Bus signal"
-        pass
-    
-    # CheckerCompleted - signal
-    @dbus.service.signal(_interface, signature="b")
-    def CheckerCompleted(self, success):
-        "D-Bus signal"
-        pass
-    
-    # CheckerIsRunning - method
-    @dbus.service.method(_interface, out_signature="b")
-    def CheckerIsRunning(self):
-        "D-Bus getter method"
-        return self.checker is not None
-    
-    # CheckerStarted - signal
-    @dbus.service.signal(_interface, signature="s")
-    def CheckerStarted(self, command):
-        "D-Bus signal"
-        pass
-    
-    # GetChecker - method
-    @dbus.service.method(_interface, out_signature="s")
-    def GetChecker(self):
-        "D-Bus getter method"
-        return self.checker_command
-    
-    # GetCreated - method
-    @dbus.service.method(_interface, out_signature="(nyyyyyu)")
-    def GetCreated(self):
-        "D-Bus getter method"
-        return datetime_to_dbus_struct(self.created)
-    
-    # GetFingerprint - method
-    @dbus.service.method(_interface, out_signature="s")
-    def GetFingerprint(self):
-        "D-Bus getter method"
-        return self.fingerprint
-    
-    # GetHost - method
-    @dbus.service.method(_interface, out_signature="s")
-    def GetHost(self):
-        "D-Bus getter method"
-        return self.host
-    
-    # GetInterval - method
-    @dbus.service.method(_interface, out_signature="t")
-    def GetInterval(self):
-        "D-Bus getter method"
-        return self._interval_milliseconds
-    
-    # GetName - method
-    @dbus.service.method(_interface, out_signature="s")
-    def GetName(self):
-        "D-Bus getter method"
-        return self.name
-    
-    # GetStarted - method
-    @dbus.service.method(_interface, out_signature="(nyyyyyu)")
-    def GetStarted(self):
-        "D-Bus getter method"
-        if self.started is not None:
-            return datetime_to_dbus_struct(self.started)
-        else:
-            return dbus.Struct(0, 0, 0, 0, 0, 0, 0,
-                               signature="nyyyyyu")
-    
-    # GetTimeout - method
-    @dbus.service.method(_interface, out_signature="t")
-    def GetTimeout(self):
-        "D-Bus getter method"
-        return self._timeout_milliseconds
-    
-    # SetChecker - method
-    @dbus.service.method(_interface, in_signature="s")
-    def SetChecker(self, checker):
-        "D-Bus setter method"
-        self.checker_command = checker
-    
-    # SetHost - method
-    @dbus.service.method(_interface, in_signature="s")
-    def SetHost(self, host):
-        "D-Bus setter method"
-        self.host = host
-    
-    # SetInterval - method
-    @dbus.service.method(_interface, in_signature="t")
-    def SetInterval(self, milliseconds):
-        self.interval = datetime.timdeelta(0, 0, 0, milliseconds)
-    
-    # SetTimeout - method
-    @dbus.service.method(_interface, in_signature="t")
-    def SetTimeout(self, milliseconds):
-        self.timeout = datetime.timedelta(0, 0, 0, milliseconds)
-    
-    # SetSecret - method
-    @dbus.service.method(_interface, in_signature="ay",
-                         byte_arrays=True)
-    def SetSecret(self, secret):
-        "D-Bus setter method"
-        self.secret = str(secret)
-    
-    # Start - method
-    Start = dbus.service.method(_interface)(start)
-    Start.__name__ = "Start"
-    
-    # StartChecker - method
-    StartChecker = dbus.service.method(_interface)(start_checker)
-    StartChecker.__name__ = "StartChecker"
-    
-    # StateChanged - signal
-    @dbus.service.signal(_interface, signature="b")
-    def StateChanged(self, started):
-        "D-Bus signal"
-        pass
-    
-    # StillValid - method
-    StillValid = (dbus.service.method(_interface, out_signature="b")
-                  (still_valid))
-    StillValid.__name__ = "StillValid"
-    
-    # Stop - method
-    Stop = dbus.service.method(_interface)(stop)
-    Stop.__name__ = "Stop"
-    
-    # StopChecker - method
-    StopChecker = dbus.service.method(_interface)(stop_checker)
-    StopChecker.__name__ = "StopChecker"
-    
-    # TimeoutChanged - signal
-    @dbus.service.signal(_interface, signature="t")
-    def TimeoutChanged(self, t):
-        "D-Bus signal"
-        pass
-    
-    del _datetime_to_dbus_struct
-    del _interface
 
 
 def peer_certificate(session):
     "Return the peer's OpenPGP certificate as a bytestring"
     # If not an OpenPGP certificate...
-    if (gnutls.library.functions
-        .gnutls_certificate_type_get(session._c_object)
-        != gnutls.library.constants.GNUTLS_CRT_OPENPGP):
+    if gnutls.library.functions.gnutls_certificate_type_get\
+            (session._c_object) \
+           != gnutls.library.constants.GNUTLS_CRT_OPENPGP:
         # ...do the normal thing
         return session.peer_certificate
     list_size = ctypes.c_uint()
-    cert_list = (gnutls.library.functions
-                 .gnutls_certificate_get_peers
-                 (session._c_object, ctypes.byref(list_size)))
+    cert_list = gnutls.library.functions.gnutls_certificate_get_peers\
+        (session._c_object, ctypes.byref(list_size))
     if list_size.value == 0:
         return None
     cert = cert_list[0]
@@ -594,24 +405,22 @@
 def fingerprint(openpgp):
     "Convert an OpenPGP bytestring to a hexdigit fingerprint string"
     # New GnuTLS "datum" with the OpenPGP public key
-    datum = (gnutls.library.types
-             .gnutls_datum_t(ctypes.cast(ctypes.c_char_p(openpgp),
-                                         ctypes.POINTER
-                                         (ctypes.c_ubyte)),
-                             ctypes.c_uint(len(openpgp))))
+    datum = gnutls.library.types.gnutls_datum_t\
+        (ctypes.cast(ctypes.c_char_p(openpgp),
+                     ctypes.POINTER(ctypes.c_ubyte)),
+         ctypes.c_uint(len(openpgp)))
     # New empty GnuTLS certificate
     crt = gnutls.library.types.gnutls_openpgp_crt_t()
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_init(ctypes.byref(crt)))
+    gnutls.library.functions.gnutls_openpgp_crt_init\
+        (ctypes.byref(crt))
     # Import the OpenPGP public key into the certificate
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_import(crt, ctypes.byref(datum),
-                                gnutls.library.constants
-                                .GNUTLS_OPENPGP_FMT_RAW))
+    gnutls.library.functions.gnutls_openpgp_crt_import\
+                    (crt, ctypes.byref(datum),
+                     gnutls.library.constants.GNUTLS_OPENPGP_FMT_RAW)
     # Verify the self signature in the key
     crtverify = ctypes.c_uint()
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_verify_self(crt, 0, ctypes.byref(crtverify)))
+    gnutls.library.functions.gnutls_openpgp_crt_verify_self\
+        (crt, 0, ctypes.byref(crtverify))
     if crtverify.value != 0:
         gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
         raise gnutls.errors.CertificateSecurityError("Verify failed")
@@ -619,9 +428,8 @@
     buf = ctypes.create_string_buffer(20)
     buf_len = ctypes.c_size_t()
     # Get the fingerprint from the certificate into the buffer
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_get_fingerprint(crt, ctypes.byref(buf),
-                                         ctypes.byref(buf_len)))
+    gnutls.library.functions.gnutls_openpgp_crt_get_fingerprint\
+        (crt, ctypes.byref(buf), ctypes.byref(buf_len))
     # Deinit the certificate
     gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
     # Convert the buffer to a Python bytestring
@@ -638,11 +446,9 @@
     
     def handle(self):
         logger.info(u"TCP connection from: %s",
-                    unicode(self.client_address))
-        session = (gnutls.connection
-                   .ClientSession(self.request,
-                                  gnutls.connection
-                                  .X509Credentials()))
+                     unicode(self.client_address))
+        session = gnutls.connection.ClientSession\
+                  (self.request, gnutls.connection.X509Credentials())
         
         line = self.request.makefile().readline()
         logger.debug(u"Protocol version: %r", line)
@@ -661,11 +467,12 @@
         #priority = ':'.join(("NONE", "+VERS-TLS1.1", "+AES-256-CBC",
         #                "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
         #                "+DHE-DSS"))
-        # Use a fallback default, since this MUST be set.
-        priority = self.server.settings.get("priority", "NORMAL")
-        (gnutls.library.functions
-         .gnutls_priority_set_direct(session._c_object,
-                                     priority, None))
+        priority = "NORMAL"             # Fallback default, since this
+                                        # MUST be set.
+        if self.server.settings["priority"]:
+            priority = self.server.settings["priority"]
+        gnutls.library.functions.gnutls_priority_set_direct\
+            (session._c_object, priority, None)
         
         try:
             session.handshake()
@@ -681,11 +488,12 @@
             session.bye()
             return
         logger.debug(u"Fingerprint: %s", fpr)
+        client = None
         for c in self.server.clients:
             if c.fingerprint == fpr:
                 client = c
                 break
-        else:
+        if not client:
             logger.warning(u"Client not found for fingerprint: %s",
                            fpr)
             session.bye()
@@ -698,8 +506,6 @@
                            vars(client))
             session.bye()
             return
-        ## This won't work here, since we're in a fork.
-        # client.bump_timeout()
         sent_size = 0
         while sent_size < len(client.secret):
             sent = session.send(client.secret[sent_size:])
@@ -710,8 +516,7 @@
         session.bye()
 
 
-class IPv6_TCPServer(SocketServer.ForkingMixIn,
-                     SocketServer.TCPServer, object):
+class IPv6_TCPServer(SocketServer.ForkingTCPServer, object):
     """IPv6 TCP server.  Accepts 'None' as address and/or port.
     Attributes:
         settings:       Server settings
@@ -836,9 +641,8 @@
     """Call the C function if_nametoindex(), or equivalent"""
     global if_nametoindex
     try:
-        if_nametoindex = (ctypes.cdll.LoadLibrary
-                          (ctypes.util.find_library("c"))
-                          .if_nametoindex)
+        if_nametoindex = ctypes.cdll.LoadLibrary\
+            (ctypes.util.find_library("c")).if_nametoindex
     except (OSError, AttributeError):
         if "struct" not in sys.modules:
             import struct
@@ -847,9 +651,10 @@
         def if_nametoindex(interface):
             "Get an interface index the hard way, i.e. using fcntl()"
             SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
-            with closing(socket.socket()) as s:
-                ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                    struct.pack("16s16x", interface))
+            s = socket.socket()
+            ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
+                                struct.pack("16s16x", interface))
+            s.close()
             interface_index = struct.unpack("I", ifreq[16:20])[0]
             return interface_index
     return if_nametoindex(interface)
@@ -923,8 +728,8 @@
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
     # Use getboolean on the boolean config option
-    server_settings["debug"] = (server_config.getboolean
-                                ("DEFAULT", "debug"))
+    server_settings["debug"] = server_config.getboolean\
+                               ("DEFAULT", "debug")
     del server_config
     
     # Override the settings from the config file with command line
@@ -944,7 +749,7 @@
         console.setLevel(logging.WARNING)
     
     if server_settings["servicename"] != "Mandos":
-        syslogger.setFormatter(logging.Formatter
+        syslogger.setFormatter(logging.Formatter\
                                ('Mandos (%s): %%(levelname)s:'
                                 ' %%(message)s'
                                 % server_settings["servicename"]))
@@ -998,8 +803,8 @@
     service = AvahiService(name = server_settings["servicename"],
                            servicetype = "_mandos._tcp", )
     if server_settings["interface"]:
-        service.interface = (if_nametoindex
-                             (server_settings["interface"]))
+        service.interface = if_nametoindex\
+                            (server_settings["interface"])
     
     global main_loop
     global bus
@@ -1012,7 +817,6 @@
                                            avahi.DBUS_PATH_SERVER),
                             avahi.DBUS_INTERFACE_SERVER)
     # End of Avahi example code
-    bus_name = dbus.service.BusName(u"org.mandos-system.Mandos", bus)
     
     def remove_from_clients(client):
         clients.remove(client)
@@ -1100,8 +904,8 @@
         
         gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
                              lambda *args, **kwargs:
-                             (tcp_server.handle_request
-                              (*args[2:], **kwargs) or True))
+                             tcp_server.handle_request\
+                             (*args[2:], **kwargs) or True)
         
         logger.debug(u"Starting main loop")
         main_loop.run()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2008-10-07 21:31:09 +0000
+++ mandos-clients.conf.xml	2008-09-12 19:12:40 +0000
@@ -1,11 +1,10 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2008-10-07">
-<!ENTITY % common SYSTEM "common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-12">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -13,7 +12,7 @@
     <title>Mandos Manual</title>
     <!-- NWalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>
@@ -240,11 +239,6 @@
 	    should <emphasis>not</emphasis> be base64-encoded, but
 	    will be sent to clients verbatim.
 	  </para>
-	  <para>
-	    File names of the form <filename>~user/foo/bar</filename>
-	    and <filename>$<envar>ENVVAR</envar>/foo/bar</filename>
-	    are supported.
-	  </para>
 	</listitem>
       </varlistentry>
       

=== modified file 'mandos-keygen'
--- mandos-keygen	2008-11-11 16:07:18 +0000
+++ mandos-keygen	2008-09-21 14:05:44 +0000
@@ -2,8 +2,7 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008 Teddy Hogeborn
-# Copyright © 2008 Björn Påhlsson
+# Copyright © 2008 Teddy Hogeborn & Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.0.2"
+VERSION="1.0"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA
@@ -290,7 +289,7 @@
 	fi
     fi | gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always --armor --encrypt \
-	--sign --recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
+	--recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
 	> "$SECFILE"
     status="${PIPESTATUS[0]}"
     if [ "$status" -ne 0 ]; then

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2008-10-04 01:55:56 +0000
+++ mandos-keygen.xml	2008-09-19 23:31:34 +0000
@@ -1,10 +1,9 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2008-10-03">
-<!ENTITY % common SYSTEM "common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-20">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -12,7 +11,7 @@
     <title>Mandos Manual</title>
     <!-- NWalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>
@@ -382,7 +381,7 @@
     </variablelist>
   </refsect1>
   
-  <refsect1 id="files">
+  <refsect1 id="file">
     <title>FILES</title>
     <para>
       Use the <option>--dir</option> option to change where

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2008-09-30 07:23:39 +0000
+++ mandos.conf.xml	2008-09-12 19:12:40 +0000
@@ -1,11 +1,10 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2008-09-30">
-<!ENTITY % common SYSTEM "common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-12">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -13,7 +12,7 @@
     <title>Mandos Manual</title>
     <!-- NWalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>

=== removed file 'mandos.lsm'
--- mandos.lsm	2008-10-18 10:58:29 +0000
+++ mandos.lsm	1970-01-01 00:00:00 +0000
@@ -1,22 +0,0 @@
-Begin4
-Title:		Mandos
-Version:	1.0.2
-Entered-date:	2008-10-18
-Description:	The Mandos system allows computers to have encrypted
-root file systems and at the same time be capable of remote and/or
-unattended reboots.
-Keywords:	boot, encryption, luks, cryptsetup, network, openpgp,
-tls, dm-crypt
-Author:		teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Primary-site: http://www.fukt.bsnet.se/mandos
-	      89K mandos_1.0.2.orig.tar.gz
-Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		89K mandos_1.0.2.orig.tar.gz
-Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.4, and
-various other libraries.  While made for Debian GNU/Linux, it is
-probably portable to other distributions, but not other Unixes.
-Copying-policy: GNU General Public License version 3.0 or later
-End

=== modified file 'mandos.xml'
--- mandos.xml	2008-10-04 01:55:56 +0000
+++ mandos.xml	2008-09-21 12:20:55 +0000
@@ -1,18 +1,17 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2008-10-03">
-<!ENTITY % common SYSTEM "common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-21">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
-   <refentryinfo>
+  <refentryinfo>
     <title>Mandos Manual</title>
     <!-- NWalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>
@@ -351,7 +350,7 @@
     </variablelist>
   </refsect1>
   
-  <refsect1 id="files">
+  <refsect1 id="file">
     <title>FILES</title>
     <para>
       Use the <option>--configdir</option> option to change where
@@ -421,7 +420,7 @@
       Currently, if a client is declared <quote>invalid</quote> due to
       having timed out, the server does not record this fact onto
       permanent storage.  This has some security implications, see
-      <xref linkend="clients"/>.
+      <xref linkend="CLIENTS"/>.
     </para>
     <para>
       There is currently no way of querying the server of the current
@@ -483,7 +482,7 @@
   
   <refsect1 id="security">
     <title>SECURITY</title>
-    <refsect2 id="server">
+    <refsect2 id="SERVER">
       <title>SERVER</title>
       <para>
 	Running this <command>&COMMANDNAME;</command> server program
@@ -492,7 +491,7 @@
 	soon after startup.
       </para>
     </refsect2>
-    <refsect2 id="clients">
+    <refsect2 id="CLIENTS">
       <title>CLIENTS</title>
       <para>
 	The server only gives out its stored data to clients which

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2008-11-11 16:07:18 +0000
+++ plugin-runner.c	2008-09-26 04:54:35 +0000
@@ -2,8 +2,7 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
+ * Copyright © 2008 Teddy Hogeborn & Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -70,7 +69,7 @@
 #define PDIR "/lib/mandos/plugins.d"
 #define AFILE "/conf/conf.d/mandos/plugin-runner.conf"
 
-const char *argp_program_version = "plugin-runner " VERSION;
+const char *argp_program_version = "plugin-runner 1.0";
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
 typedef struct plugin{
@@ -701,7 +700,6 @@
       
       const char const *bad_suffixes[] = { "~", "#", ".dpkg-new",
 					   ".dpkg-old",
-					   ".dpkg-bak",
 					   ".dpkg-divert", NULL };
       for(const char **pre = bad_prefixes; *pre != NULL; pre++){
 	size_t pre_len = strlen(*pre);

=== modified file 'plugin-runner.conf'
--- plugin-runner.conf	2008-10-05 17:38:31 +0000
+++ plugin-runner.conf	2008-09-06 16:31:49 +0000
@@ -1,11 +1,9 @@
 ## This is the configuration file for plugin-runner.  It should be
 ## installed as "/etc/mandos/plugin-runner.conf", which will be copied
 ## to "/conf/conf.d/mandos/plugin-runner.conf" in the initrd.img file.
-##
-## After editing this file, the initrd image file must be updated for
-## the changes to take effect!
 ## 
 ## The default network interface for mandos-client(8mandos) is
 ## "eth0".  Uncomment this line and change it if necessary.
 ## 
+
 #--options-for=mandos-client:--interface=eth0

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2008-09-30 07:23:39 +0000
+++ plugin-runner.xml	2008-09-19 00:00:51 +0000
@@ -1,10 +1,9 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2008-09-30">
-<!ENTITY % common SYSTEM "common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-19">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -12,7 +11,7 @@
     <title>Mandos Manual</title>
     <!-- Nwalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2008-11-11 16:07:18 +0000
+++ plugins.d/askpass-fifo.c	2008-09-26 19:47:21 +0000
@@ -1,28 +1,3 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Passprompt - Read a password from a FIFO and output it
- * 
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
 #include <sys/types.h>		/* ssize_t */
 #include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */

=== removed file 'plugins.d/askpass-fifo.xml'
--- plugins.d/askpass-fifo.xml	2008-10-04 20:09:53 +0000
+++ plugins.d/askpass-fifo.xml	1970-01-01 00:00:00 +0000
@@ -1,161 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
-	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY COMMANDNAME "askpass-fifo">
-<!ENTITY TIMESTAMP "2008-10-04">
-<!ENTITY % common SYSTEM "../common.ent">
-%common;
-]>
-
-<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
-  <refentryinfo>
-    <title>Mandos Manual</title>
-    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
-    <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
-    <date>&TIMESTAMP;</date>
-    <authorgroup>
-      <author>
-	<firstname>Björn</firstname>
-	<surname>Påhlsson</surname>
-	<address>
-	  <email>belorn@fukt.bsnet.se</email>
-	</address>
-      </author>
-      <author>
-	<firstname>Teddy</firstname>
-	<surname>Hogeborn</surname>
-	<address>
-	  <email>teddy@fukt.bsnet.se</email>
-	</address>
-      </author>
-    </authorgroup>
-    <copyright>
-      <year>2008</year>
-      <holder>Teddy Hogeborn</holder>
-      <holder>Björn Påhlsson</holder>
-    </copyright>
-    <xi:include href="../legalnotice.xml"/>
-  </refentryinfo>
-  
-  <refmeta>
-    <refentrytitle>&COMMANDNAME;</refentrytitle>
-    <manvolnum>8mandos</manvolnum>
-  </refmeta>
-  
-  <refnamediv>
-    <refname><command>&COMMANDNAME;</command></refname>
-    <refpurpose>Mandos plugin to get a password from a
-    FIFO.</refpurpose>
-  </refnamediv>
-  
-  <refsynopsisdiv>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-    </cmdsynopsis>
-  </refsynopsisdiv>
-  
-  <refsect1 id="description">
-    <title>DESCRIPTION</title>
-    <para>
-      This program reads a password from a <acronym>FIFO</acronym> and
-      outputs it to standard output.
-    </para>
-    <para>
-      This program is not very useful on its own.  This program is
-      really meant to run as a plugin in the <application
-      >Mandos</application> client-side system, where it is used as a
-      fallback and alternative to retrieving passwords from a
-      <application >Mandos</application> server.
-    </para>
-    <para>
-      This program is meant to be imitate a feature of the
-      <command>askpass</command> program, so that programs written to
-      interface with it can keep working under the
-      <application>Mandos</application> system.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="options">
-    <title>OPTIONS</title>
-    <para>
-      This program takes no options.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="exit_status">
-    <title>EXIT STATUS</title>
-    <para>
-      If exit status is 0, the output from the program is the password
-      as it was read.  Otherwise, if exit status is other than 0, the
-      program was interrupted or encountered an error, and any output
-      so far could be corrupt and/or truncated, and should therefore
-      be ignored.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="files">
-    <title>FILES</title>
-    <variablelist>
-      <varlistentry>
-	<term><filename>/lib/cryptsetup/passfifo</filename></term>
-	<listitem>
-	  <para>
-	    This is the <acronym>FIFO</acronym> where this program
-	    will read the password.  If it does not exist, it will be
-	    created.
-	  </para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="example">
-    <title>EXAMPLE</title>
-    <para>
-      Note that normally, this program will not be invoked directly,
-      but instead started by the Mandos <citerefentry><refentrytitle
-      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum>
-      </citerefentry>.
-    </para>
-    <informalexample>
-      <para>
-	This program takes no options.
-      </para>
-      <para>
-	<userinput>&COMMANDNAME;</userinput>
-      </para>
-    </informalexample>
-  </refsect1>
-  
-  <refsect1 id="security">
-    <title>SECURITY</title>
-    <para>
-      The only thing that could be considered worthy of note is
-      this:  This program is meant to be run by <citerefentry>
-      <refentrytitle>plugin-runner</refentrytitle><manvolnum
-      >8mandos</manvolnum></citerefentry>, and will, when run
-      standalone, outside, in a normal environment, immediately output
-      on its standard output any presumably secret password it just
-      received.  Therefore, when running this program standalone
-      (which should never normally be done), take care not to type in
-      any real secret password by force of habit, since it would then
-      immediately be shown as output.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="see_also">
-    <title>SEE ALSO</title>
-    <para>
-      <citerefentry><refentrytitle>fifo</refentrytitle>
-      <manvolnum>7</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>
-    </para>
-  </refsect1>
-</refentry>
-<!-- Local Variables: -->
-<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
-<!-- time-stamp-end: "[\"']>" -->
-<!-- time-stamp-format: "%:y-%02m-%02d" -->
-<!-- End: -->

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2008-11-11 16:07:18 +0000
+++ plugins.d/mandos-client.c	2008-09-19 20:42:17 +0000
@@ -9,8 +9,7 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
+ * Copyright © 2008 Teddy Hogeborn & Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -102,13 +101,17 @@
 
 #define BUFFER_SIZE 256
 
+/*
+  #define PATHDIR "/conf/conf.d/mandos"
+*/
+
 #define PATHDIR "/conf/conf.d/mandos"
 #define SECKEY "seckey.txt"
 #define PUBKEY "pubkey.txt"
 
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
-const char *argp_program_version = "mandos-client " VERSION;
+const char *argp_program_version = "mandos-client 1.0";
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
 /* Used for passing in values through the Avahi callback functions */

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2008-10-04 01:55:56 +0000
+++ plugins.d/mandos-client.xml	2008-09-30 03:19:39 +0000
@@ -1,18 +1,17 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2008-10-03">
-<!ENTITY % common SYSTEM "../common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-30">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
   <refentryinfo>
     <title>Mandos Manual</title>
-    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
+    <!-- Nwalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>
@@ -344,7 +343,7 @@
     </para>
   </refsect1>
   
-  <refsect1 id="files">
+  <refsect1 id="file">
     <title>FILES</title>
     <variablelist>
       <varlistentry>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2008-11-11 16:07:18 +0000
+++ plugins.d/password-prompt.c	2008-09-19 20:42:17 +0000
@@ -1,9 +1,8 @@
 /*  -*- coding: utf-8 -*- */
 /*
  * Passprompt - Read a password from the terminal and print it
- * 
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
+ *
+ * Copyright © 2008 Teddy Hogeborn & Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -53,7 +52,7 @@
 
 volatile bool quit_now = false;
 bool debug = false;
-const char *argp_program_version = "password-prompt " VERSION;
+const char *argp_program_version = "password-prompt 1.0";
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
 static void termination_handler(__attribute__((unused))int signum){

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2008-10-04 01:55:56 +0000
+++ plugins.d/password-prompt.xml	2008-09-06 16:31:49 +0000
@@ -1,10 +1,9 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2008-10-04">
-<!ENTITY % common SYSTEM "../common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-06">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -12,7 +11,7 @@
     <title>Mandos Manual</title>
     <!-- NWalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>
@@ -84,14 +83,12 @@
     <title>DESCRIPTION</title>
     <para>
       All <command>&COMMANDNAME;</command> does is prompt for a
-      password and output any given password to standard output.
-    </para>
-    <para>
-      This program is not very useful on its own.  This program is
-      really meant to run as a plugin in the <application
-      >Mandos</application> client-side system, where it is used as a
-      fallback and alternative to retrieving passwords from a
-      <application >Mandos</application> server.
+      password and output any given password to standard output.  This
+      is not very useful on its own.  This program is really meant to
+      run as a plugin in the <application>Mandos</application>
+      client-side system, where it is used as a fallback and
+      alternative to retrieving passwords from a <application
+      >Mandos</application> server.
     </para>
     <para>
       This program is little more than a <citerefentry><refentrytitle

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2008-11-11 16:07:18 +0000
+++ plugins.d/splashy.c	2008-09-24 23:03:31 +0000
@@ -1,47 +1,20 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Passprompt - Read a password from splashy and output it
- * 
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
 #define _GNU_SOURCE		/* asprintf() */
 #include <signal.h>		/* sig_atomic_t, struct sigaction,
-				   sigemptyset(), sigaddset(), SIGINT,
-				   SIGHUP, SIGTERM, sigaction,
-				   SIG_IGN, kill(), SIGKILL */
+				   sigemptyset(), sigaddset(),
+				   sigaction, SIGINT, SIG_IGN, SIGHUP,
+				   SIGTERM, kill(), SIGKILL */
 #include <stddef.h>		/* NULL */
 #include <stdlib.h>		/* getenv() */
 #include <stdio.h>		/* asprintf(), perror() */
-#include <stdlib.h>		/* EXIT_FAILURE, free(), strtoul(),
-				   EXIT_SUCCESS */
+#include <stdlib.h>		/* EXIT_FAILURE, EXIT_SUCCESS,
+				   strtoul(), free() */
 #include <sys/types.h>		/* pid_t, DIR, struct dirent,
 				   ssize_t */
 #include <dirent.h>		/* opendir(), readdir(), closedir() */
-#include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
-#include <iso646.h>		/* not, or, and */
 #include <unistd.h>		/* readlink(), fork(), execl(),
-				   sleep(), dup2() STDERR_FILENO,
-				   STDOUT_FILENO, _exit() */
+				   _exit */
 #include <string.h>		/* memcmp() */
+#include <iso646.h>		/* and */
 #include <errno.h>		/* errno */
 #include <sys/wait.h>		/* waitpid(), WIFEXITED(),
 				   WEXITSTATUS() */
@@ -115,24 +88,6 @@
 	  closedir(proc_dir);
 	  return EXIT_FAILURE;
 	}
-	
-	/* Check that it refers to a symlink owned by root:root */
-	struct stat exe_stat;
-	ret = lstat(exe_link, &exe_stat);
-	if(ret == -1){
-	  perror("lstat");
-	  free(exe_link);
-	  free(prompt);
-	  closedir(proc_dir);
-	  return EXIT_FAILURE;
-	}
-	if(not S_ISLNK(exe_stat.st_mode)
-	   or exe_stat.st_uid != 0
-	   or exe_stat.st_gid != 0){
-	  free(exe_link);
-	  continue;
-	}
-	
 	sret = readlink(exe_link, exe_target, sizeof(exe_target));
 	free(exe_link);
       }
@@ -165,7 +120,7 @@
       free(prompt);
       return EXIT_FAILURE;
     }
-    if(old_action.sa_handler != SIG_IGN){
+    if (old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
@@ -179,7 +134,7 @@
       free(prompt);
       return EXIT_FAILURE;
     }
-    if(old_action.sa_handler != SIG_IGN){
+    if (old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
@@ -193,7 +148,7 @@
       free(prompt);
       return EXIT_FAILURE;
     }
-    if(old_action.sa_handler != SIG_IGN){
+    if (old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
@@ -218,11 +173,13 @@
       const char splashy_command[] = "/sbin/splashy_update";
       ret = execl(splashy_command, splashy_command, prompt,
 		  (char *)NULL);
-      if(not interrupted_by_signal){
+      if(not interrupted_by_signal and errno != ENOENT){
+	/* Don't report "File not found", since splashy might not be
+	   installed. */
 	perror("execl");
       }
       free(prompt);
-      _exit(EXIT_FAILURE);
+      return EXIT_FAILURE;
     }
   }
   
@@ -230,61 +187,33 @@
   free(prompt);
   
   /* Wait for command to complete */
-  if(not interrupted_by_signal and splashy_command_pid != 0){
-    int status;
-    ret = waitpid(splashy_command_pid, &status, 0);
-    if(ret == -1){
-      if(errno != EINTR){
-	perror("waitpid");
-      }
-      if(errno == ECHILD){
-	splashy_command_pid = 0;
-      }
-    } else {
-      /* The child process has exited */
-      splashy_command_pid = 0;
-      if(not interrupted_by_signal and WIFEXITED(status)
-	 and WEXITSTATUS(status)==0){
-	return EXIT_SUCCESS;
-      }
+  int status;
+  while(not interrupted_by_signal){
+    waitpid(splashy_command_pid, &status, 0);
+    if(not interrupted_by_signal
+       and WIFEXITED(status) and WEXITSTATUS(status)==0){
+      return EXIT_SUCCESS;
     }
   }
   kill(splashy_pid, SIGTERM);
-  if(interrupted_by_signal and splashy_command_pid != 0){
+  if(interrupted_by_signal){
     kill(splashy_command_pid, SIGTERM);
   }
-  sleep(2);
-  while(kill(splashy_pid, 0) == 0){
-    kill(splashy_pid, SIGKILL);
-    sleep(1);
-  }
+  
   pid_t new_splashy_pid = fork();
   if(new_splashy_pid == 0){
     /* Child; will become new splashy process */
-    
-    /* Make the effective user ID (root) the only user ID instead of
-       the real user ID (mandos) */
-    ret = setuid(geteuid());
-    if(ret == -1){
-      perror("setuid");
+    while(kill(splashy_pid, 0)){
+      sleep(2);
+      kill(splashy_pid, SIGKILL);
+      sleep(1);
     }
-    
-    setsid();
-    ret = chdir("/");
-/*     if(fork() != 0){ */
-/*       _exit(EXIT_SUCCESS); */
-/*     } */
     ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
     if(ret == -1){
       perror("dup2");
       _exit(EXIT_FAILURE);
     }
-    
     execl("/sbin/splashy", "/sbin/splashy", "boot", (char *)NULL);
-    if(not interrupted_by_signal){
-      perror("execl");
-    }
-    _exit(EXIT_FAILURE);
   }
   
   return EXIT_FAILURE;

=== removed file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2008-10-04 03:11:39 +0000
+++ plugins.d/splashy.xml	1970-01-01 00:00:00 +0000
@@ -1,282 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
-	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY COMMANDNAME "splashy">
-<!ENTITY TIMESTAMP "2008-10-04">
-<!ENTITY % common SYSTEM "../common.ent">
-%common;
-]>
-
-<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
-  <refentryinfo>
-    <title>Mandos Manual</title>
-    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
-    <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
-    <date>&TIMESTAMP;</date>
-    <authorgroup>
-      <author>
-	<firstname>Björn</firstname>
-	<surname>Påhlsson</surname>
-	<address>
-	  <email>belorn@fukt.bsnet.se</email>
-	</address>
-      </author>
-      <author>
-	<firstname>Teddy</firstname>
-	<surname>Hogeborn</surname>
-	<address>
-	  <email>teddy@fukt.bsnet.se</email>
-	</address>
-      </author>
-    </authorgroup>
-    <copyright>
-      <year>2008</year>
-      <holder>Teddy Hogeborn</holder>
-      <holder>Björn Påhlsson</holder>
-    </copyright>
-    <xi:include href="../legalnotice.xml"/>
-  </refentryinfo>
-  
-  <refmeta>
-    <refentrytitle>&COMMANDNAME;</refentrytitle>
-    <manvolnum>8mandos</manvolnum>
-  </refmeta>
-  
-  <refnamediv>
-    <refname><command>&COMMANDNAME;</command></refname>
-    <refpurpose>Mandos plugin to use splashy to get a
-    password.</refpurpose>
-  </refnamediv>
-  
-  <refsynopsisdiv>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-    </cmdsynopsis>
-  </refsynopsisdiv>
-  
-  <refsect1 id="description">
-    <title>DESCRIPTION</title>
-    <para>
-      This program prompts for a password using <citerefentry>
-      <refentrytitle>splashy_update</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> and outputs any given
-      password to standard output.  If no <citerefentry><refentrytitle
-      >splashy</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      process can be found, this program will immediately exit with an
-      exit code indicating failure.
-    </para>
-    <para>
-      This program is not very useful on its own.  This program is
-      really meant to run as a plugin in the <application
-      >Mandos</application> client-side system, where it is used as a
-      fallback and alternative to retrieving passwords from a
-      <application >Mandos</application> server.
-    </para>
-    <para>
-      If this program is killed (presumably by
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry> because some other
-      plugin provided the password), it cannot tell <citerefentry>
-      <refentrytitle>splashy</refentrytitle><manvolnum>8</manvolnum>
-      </citerefentry> to abort requesting a password, because
-      <citerefentry><refentrytitle>splashy</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> does not support this.
-      Therefore, this program will then <emphasis>kill</emphasis> the
-      running <citerefentry><refentrytitle>splashy</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> process and start a
-      <emphasis>new</emphasis> one, using <quote><literal
-      >boot</literal></quote> as the only argument.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="options">
-    <title>OPTIONS</title>
-    <para>
-      This program takes no options.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="exit_status">
-    <title>EXIT STATUS</title>
-    <para>
-      If exit status is 0, the output from the program is the password
-      as it was read.  Otherwise, if exit status is other than 0, the
-      program was interrupted or encountered an error, and any output
-      so far could be corrupt and/or truncated, and should therefore
-      be ignored.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="environment">
-    <title>ENVIRONMENT</title>
-    <variablelist>
-      <varlistentry>
-	<term><envar>cryptsource</envar></term>
-	<term><envar>crypttarget</envar></term>
-	<listitem>
-	  <para>
-	    If set, these environment variables will be assumed to
-	    contain the source device name and the target device
-	    mapper name, respectively, and will be shown as part of
-	    the prompt.
-	</para>
-	<para>
-	  These variables will normally be inherited from
-	  <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-	  <manvolnum>8mandos</manvolnum></citerefentry>, which will
-	  normally have inherited them from
-	  <filename>/scripts/local-top/cryptroot</filename> in the
-	  initial <acronym>RAM</acronym> disk environment, which will
-	  have set them from parsing kernel arguments and
-	  <filename>/conf/conf.d/cryptroot</filename> (also in the
-	  initial RAM disk environment), which in turn will have been
-	  created when the initial RAM disk image was created by
-	  <filename
-	  >/usr/share/initramfs-tools/hooks/cryptroot</filename>, by
-	  extracting the information of the root file system from
-	  <filename >/etc/crypttab</filename>.
-	</para>
-	<para>
-	  This behavior is meant to exactly mirror the behavior of
-	  <command>askpass</command>, the default password prompter.
-	</para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="files">
-    <title>FILES</title>
-    <variablelist>
-      <varlistentry>
-	<term><filename>/sbin/splashy_update</filename></term>
-	<listitem>
-	  <para>
-	    This is the command run to retrieve a password from
-	    <citerefentry><refentrytitle>splashy</refentrytitle>
-	    <manvolnum>8</manvolnum></citerefentry>.  See
-	    <citerefentry><refentrytitle
-	    >splashy_update</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/proc</filename></term>
-	<listitem>
-	  <para>
-	    To find the running <citerefentry><refentrytitle
-	    >splashy</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>, this directory will be searched for
-	    numeric entries which will be assumed to be directories.
-	    In all those directories, the <filename>exe</filename>
-	    entry will be used to determine the name of the running
-	    binary and the effective user and group
-	    <abbrev>ID</abbrev> of the process.  See <citerefentry>
-	    <refentrytitle>proc</refentrytitle><manvolnum
-	    >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/sbin/splashy</filename></term>
-	<listitem>
-	  <para>
-	    This is the name of the binary which will be searched for
-	    in the process list.  See <citerefentry><refentrytitle
-	    >splashy</refentrytitle><manvolnum>8</manvolnum>
-	  </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="bugs">
-    <title>BUGS</title>
-    <para>
-      Killing <citerefentry><refentrytitle>splashy</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> and starting a new one
-      is ugly, but necessary as long as it does not support aborting a
-      password request.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="example">
-    <title>EXAMPLE</title>
-    <para>
-      Note that normally, this program will not be invoked directly,
-      but instead started by the Mandos <citerefentry><refentrytitle
-      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum>
-      </citerefentry>.
-    </para>
-    <informalexample>
-      <para>
-	This program takes no options.
-      </para>
-      <para>
-	<userinput>&COMMANDNAME;</userinput>
-      </para>
-    </informalexample>
-  </refsect1>
-  
-  <refsect1 id="security">
-    <title>SECURITY</title>
-    <para>
-      If this program is killed by a signal, it will kill the process
-      <abbrev>ID</abbrev> which at the start of this program was
-      determined to run <citerefentry><refentrytitle
-      >splashy</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      as root (see also <xref linkend="files"/>).  There is a very
-      slight risk that, in the time between those events, that process
-      <abbrev>ID</abbrev> was freed and then taken up by another
-      process; the wrong process would then be killed.  Now, this
-      program can only be killed by the user who started it; see
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>.  This program
-      should therefore be started by a completely separate
-      non-privileged user, and no other programs should be allowed to
-      run as that special user.  This means that it is not recommended
-      to use the user "nobody" to start this program, as other
-      possibly less trusted programs could be running as "nobody", and
-      they would then be able to kill this program, triggering the
-      killing of the process <abbrev>ID</abbrev> which may or may not
-      be <citerefentry><refentrytitle>splashy</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>.
-    </para>
-    <para>
-      The only other thing that could be considered worthy of note is
-      this:  This program is meant to be run by <citerefentry>
-      <refentrytitle>plugin-runner</refentrytitle><manvolnum
-      >8mandos</manvolnum></citerefentry>, and will, when run
-      standalone, outside, in a normal environment, immediately output
-      on its standard output any presumably secret password it just
-      received.  Therefore, when running this program standalone
-      (which should never normally be done), take care not to type in
-      any real secret password by force of habit, since it would then
-      immediately be shown as output.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="see_also">
-    <title>SEE ALSO</title>
-    <para>
-      <citerefentry><refentrytitle>crypttab</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>proc</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>splashy</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>splashy_update</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>
-    </para>
-  </refsect1>
-</refentry>
-<!-- Local Variables: -->
-<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
-<!-- time-stamp-end: "[\"']>" -->
-<!-- time-stamp-format: "%:y-%02m-%02d" -->
-<!-- End: -->

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2008-11-11 16:07:18 +0000
+++ plugins.d/usplash.c	2008-09-26 19:27:46 +0000
@@ -1,28 +1,3 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Passprompt - Read a password from usplash and output it
- * 
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
 #define _GNU_SOURCE		/* asprintf() */
 #include <signal.h>		/* sig_atomic_t, struct sigaction,
 				   sigemptyset(), sigaddset(), SIGINT,
@@ -30,10 +5,9 @@
 				   SIG_IGN, kill(), SIGKILL */
 #include <stdbool.h>		/* bool, false, true */
 #include <fcntl.h>		/* open(), O_WRONLY, O_RDONLY */
-#include <iso646.h>		/* and, or, not*/
 #include <errno.h>		/* errno, EINTR */
-#include <sys/types.h>		/* size_t, ssize_t, pid_t, DIR, struct
-				   dirent */
+#include <sys/types.h>		/* size_t, ssize_t, pid_t, DIR,
+				   struct dirent */
 #include <stddef.h>		/* NULL */
 #include <string.h>		/* strlen(), memcmp() */
 #include <stdio.h>		/* asprintf(), perror() */
@@ -47,7 +21,12 @@
 				   _exit() */
 #include <stdlib.h>		/* getenv() */
 #include <dirent.h>		/* opendir(), readdir(), closedir() */
-#include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
+
+
+
+#include <iso646.h>		/* and */
+#include <sys/wait.h>		/* waitpid(), WIFEXITED(),
+				   WEXITSTATUS() */
 
 sig_atomic_t interrupted_by_signal = 0;
 
@@ -57,8 +36,8 @@
 
 static bool usplash_write(const char *cmd, const char *arg){
   /* 
-   * usplash_write("TIMEOUT", "15") will write "TIMEOUT 15\0"
-   * usplash_write("PULSATE", NULL) will write "PULSATE\0"
+   * usplash_write("TIMEOUT", "15"); -> "TIMEOUT 15\0"
+   * usplash_write("PULSATE", NULL); -> "PULSATE\0"
    * SEE ALSO
    *         usplash_write(8)
    */
@@ -178,7 +157,6 @@
 	 /proc/<pid>/exe link */
       char exe_target[sizeof(usplash_name)];
       {
-	/* create file name string */
 	char *exe_link;
 	ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
 	if(ret == -1){
@@ -187,24 +165,6 @@
 	  closedir(proc_dir);
 	  return EXIT_FAILURE;
 	}
-	
-	/* Check that it refers to a symlink owned by root:root */
-	struct stat exe_stat;
-	ret = lstat(exe_link, &exe_stat);
-	if(ret == -1){
-	  perror("lstat");
-	  free(exe_link);
-	  free(prompt);
-	  closedir(proc_dir);
-	  return EXIT_FAILURE;
-	}
-	if(not S_ISLNK(exe_stat.st_mode)
-	   or exe_stat.st_uid != 0
-	   or exe_stat.st_gid != 0){
-	  free(exe_link);
-	  continue;
-	}
-	
 	sret = readlink(exe_link, exe_target, sizeof(exe_target));
 	free(exe_link);
 	if(sret == -1){
@@ -293,7 +253,7 @@
       free(prompt);
       return EXIT_FAILURE;
     }
-    if(old_action.sa_handler != SIG_IGN){
+    if (old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
@@ -307,7 +267,7 @@
       free(prompt);
       return EXIT_FAILURE;
     }
-    if(old_action.sa_handler != SIG_IGN){
+    if (old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
@@ -321,7 +281,7 @@
       free(prompt);
       return EXIT_FAILURE;
     }
-    if(old_action.sa_handler != SIG_IGN){
+    if (old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
@@ -447,13 +407,13 @@
       return EXIT_SUCCESS;
     }
     break;			/* Big */
-  }				/* end of non-loop while() */
+  }
   
   /* If we got here, an error or interrupt must have happened */
   
-  /* Create argc and argv for new usplash*/
   int cmdline_argc = 0;
   char **cmdline_argv = malloc(sizeof(char *));
+  /* Create argv and argc for new usplash*/
   {
     size_t position = 0;
     while(position < cmdline_len){
@@ -473,8 +433,8 @@
     cmdline_argv[cmdline_argc] = NULL;
   }
   /* Kill old usplash */
-  kill(usplash_pid, SIGTERM);
-  sleep(2);
+    kill(usplash_pid, SIGTERM);
+    sleep(2);
   while(kill(usplash_pid, 0) == 0){
     kill(usplash_pid, SIGKILL);
     sleep(1);
@@ -486,7 +446,7 @@
     /* Make the effective user ID (root) the only user ID instead of
        the real user ID (mandos) */
     ret = setuid(geteuid());
-    if(ret == -1){
+    if (ret == -1){
       perror("setuid");
     }
     
@@ -502,9 +462,7 @@
     }
     
     execv(usplash_name, cmdline_argv);
-    if(not interrupted_by_signal){
-      perror("execv");
-    }
+    perror("execv");
     free(cmdline);
     free(cmdline_argv);
     _exit(EXIT_FAILURE);

=== removed file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2008-10-04 03:11:39 +0000
+++ plugins.d/usplash.xml	1970-01-01 00:00:00 +0000
@@ -1,296 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
-	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY COMMANDNAME "usplash">
-<!ENTITY TIMESTAMP "2008-10-04">
-<!ENTITY % common SYSTEM "../common.ent">
-%common;
-]>
-
-<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
-  <refentryinfo>
-    <title>Mandos Manual</title>
-    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
-    <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
-    <date>&TIMESTAMP;</date>
-    <authorgroup>
-      <author>
-	<firstname>Björn</firstname>
-	<surname>Påhlsson</surname>
-	<address>
-	  <email>belorn@fukt.bsnet.se</email>
-	</address>
-      </author>
-      <author>
-	<firstname>Teddy</firstname>
-	<surname>Hogeborn</surname>
-	<address>
-	  <email>teddy@fukt.bsnet.se</email>
-	</address>
-      </author>
-    </authorgroup>
-    <copyright>
-      <year>2008</year>
-      <holder>Teddy Hogeborn</holder>
-      <holder>Björn Påhlsson</holder>
-    </copyright>
-    <xi:include href="../legalnotice.xml"/>
-  </refentryinfo>
-  
-  <refmeta>
-    <refentrytitle>&COMMANDNAME;</refentrytitle>
-    <manvolnum>8mandos</manvolnum>
-  </refmeta>
-  
-  <refnamediv>
-    <refname><command>&COMMANDNAME;</command></refname>
-    <refpurpose>Mandos plugin to use usplash to get a
-    password.</refpurpose>
-  </refnamediv>
-  
-  <refsynopsisdiv>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-    </cmdsynopsis>
-  </refsynopsisdiv>
-  
-  <refsect1 id="description">
-    <title>DESCRIPTION</title>
-    <para>
-      This program prompts for a password using <citerefentry>
-      <refentrytitle>usplash</refentrytitle><manvolnum>8</manvolnum>
-      </citerefentry> and outputs any given password to standard
-      output.  If no <citerefentry><refentrytitle
-      >usplash</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      process can be found, this program will immediately exit with an
-      exit code indicating failure.
-    </para>
-    <para>
-      This program is not very useful on its own.  This program is
-      really meant to run as a plugin in the <application
-      >Mandos</application> client-side system, where it is used as a
-      fallback and alternative to retrieving passwords from a
-      <application >Mandos</application> server.
-    </para>
-    <para>
-      If this program is killed (presumably by
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry> because some other
-      plugin provided the password), it cannot tell <citerefentry>
-      <refentrytitle>usplash</refentrytitle><manvolnum>8</manvolnum>
-      </citerefentry> to abort requesting a password, because
-      <citerefentry><refentrytitle>usplash</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> does not support this.
-      Therefore, this program will then <emphasis>kill</emphasis> the
-      running <citerefentry><refentrytitle>usplash</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> process and start a
-      <emphasis>new</emphasis> one using the same command line
-      arguments as the old one was using.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="options">
-    <title>OPTIONS</title>
-    <para>
-      This program takes no options.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="exit_status">
-    <title>EXIT STATUS</title>
-    <para>
-      If exit status is 0, the output from the program is the password
-      as it was read.  Otherwise, if exit status is other than 0, the
-      program was interrupted or encountered an error, and any output
-      so far could be corrupt and/or truncated, and should therefore
-      be ignored.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="environment">
-    <title>ENVIRONMENT</title>
-    <variablelist>
-      <varlistentry>
-	<term><envar>cryptsource</envar></term>
-	<term><envar>crypttarget</envar></term>
-	<listitem>
-	  <para>
-	    If set, these environment variables will be assumed to
-	    contain the source device name and the target device
-	    mapper name, respectively, and will be shown as part of
-	    the prompt.
-	</para>
-	<para>
-	  These variables will normally be inherited from
-	  <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-	  <manvolnum>8mandos</manvolnum></citerefentry>, which will
-	  normally have inherited them from
-	  <filename>/scripts/local-top/cryptroot</filename> in the
-	  initial <acronym>RAM</acronym> disk environment, which will
-	  have set them from parsing kernel arguments and
-	  <filename>/conf/conf.d/cryptroot</filename> (also in the
-	  initial RAM disk environment), which in turn will have been
-	  created when the initial RAM disk image was created by
-	  <filename
-	  >/usr/share/initramfs-tools/hooks/cryptroot</filename>, by
-	  extracting the information of the root file system from
-	  <filename >/etc/crypttab</filename>.
-	</para>
-	<para>
-	  This behavior is meant to exactly mirror the behavior of
-	  <command>askpass</command>, the default password prompter.
-	</para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="files">
-    <title>FILES</title>
-    <variablelist>
-      <varlistentry>
-	<term><filename>/dev/.initramfs/usplash_fifo</filename></term>
-	<listitem>
-	  <para>
-	    This is the <acronym>FIFO</acronym> to where this program
-	    will write the commands for <citerefentry><refentrytitle
-	    >usplash</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>.  See <citerefentry><refentrytitle
-	    >fifo</refentrytitle><manvolnum>7</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/dev/.initramfs/usplash_outfifo</filename></term>
-	<listitem>
-	  <para>
-	    This is the <acronym>FIFO</acronym> where this program
-	    will read the password from <citerefentry><refentrytitle
-	    >usplash</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>.  See <citerefentry><refentrytitle
-	    >fifo</refentrytitle><manvolnum>7</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/proc</filename></term>
-	<listitem>
-	  <para>
-	    To find the running <citerefentry><refentrytitle
-	    >usplash</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>, this directory will be searched for
-	    numeric entries which will be assumed to be directories.
-	    In all those directories, the <filename>exe</filename> and
-	    <filename>cmdline</filename> entries will be used to
-	    determine the name of the running binary, effective user
-	    and group <abbrev>ID</abbrev>, and the command line
-	    arguments.  See <citerefentry><refentrytitle
-	    >proc</refentrytitle><manvolnum>5</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/sbin/usplash</filename></term>
-	<listitem>
-	  <para>
-	    This is the name of the binary which will be searched for
-	    in the process list.  See <citerefentry><refentrytitle
-	    >usplash</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="bugs">
-    <title>BUGS</title>
-    <para>
-      Killing <citerefentry><refentrytitle>usplash</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> and starting a new one
-      is ugly, but necessary as long as it does not support aborting a
-      password request.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="example">
-    <title>EXAMPLE</title>
-    <para>
-      Note that normally, this program will not be invoked directly,
-      but instead started by the Mandos <citerefentry><refentrytitle
-      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum>
-      </citerefentry>.
-    </para>
-    <informalexample>
-      <para>
-	This program takes no options.
-      </para>
-      <para>
-	<userinput>&COMMANDNAME;</userinput>
-      </para>
-    </informalexample>
-  </refsect1>
-  
-  <refsect1 id="security">
-    <title>SECURITY</title>
-    <para>
-      If this program is killed by a signal, it will kill the process
-      <abbrev>ID</abbrev> which at the start of this program was
-      determined to run <citerefentry><refentrytitle
-      >usplash</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      as root (see also <xref linkend="files"/>).  There is a very
-      slight risk that, in the time between those events, that process
-      <abbrev>ID</abbrev> was freed and then taken up by another
-      process; the wrong process would then be killed.  Now, this
-      program can only be killed by the user who started it; see
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>.  This program
-      should therefore be started by a completely separate
-      non-privileged user, and no other programs should be allowed to
-      run as that special user.  This means that it is not recommended
-      to use the user "nobody" to start this program, as other
-      possibly less trusted programs could be running as "nobody", and
-      they would then be able to kill this program, triggering the
-      killing of the process <abbrev>ID</abbrev> which may or may not
-      be <citerefentry><refentrytitle>usplash</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>.
-    </para>
-    <para>
-      The only other thing that could be considered worthy of note is
-      this:  This program is meant to be run by <citerefentry>
-      <refentrytitle>plugin-runner</refentrytitle><manvolnum
-      >8mandos</manvolnum></citerefentry>, and will, when run
-      standalone, outside, in a normal environment, immediately output
-      on its standard output any presumably secret password it just
-      received.  Therefore, when running this program standalone
-      (which should never normally be done), take care not to type in
-      any real secret password by force of habit, since it would then
-      immediately be shown as output.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="see_also">
-    <title>SEE ALSO</title>
-    <para>
-      <citerefentry><refentrytitle>crypttab</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>fifo</refentrytitle>
-      <manvolnum>7</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>proc</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>usplash</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>
-    </para>
-  </refsect1>
-</refentry>
-<!-- Local Variables: -->
-<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
-<!-- time-stamp-end: "[\"']>" -->
-<!-- time-stamp-format: "%:y-%02m-%02d" -->
-<!-- End: -->

